#include <p24fj64ga002.h>

_CONFIG1(ICS_PGx2 & JTAGEN_OFF & GCP_OFF & GWRP_OFF & FWDTEN_OFF)
_CONFIG2(0x7987)




void _ISR __attribute__((interrupt,auto_psv)) _U1RXInterrupt()
{
char rcv1,rcv2,rcv3,val;

rcv1 = U1RXREG;
rcv2 = U1RXREG;
rcv3 = U1RXREG;

if(rcv1 == 'O' || rcv1 == 'o')
	{
	 if(rcv2 == 'I' || rcv2 == 'i')
	 	{
			OC1CON = 0x0006;
			OC2CON = 0x0000;
			_LATB9 = 0;
			_LATB7 = 0;
			_LATB6 = 1;
			val = rcv3 - '0';

			switch(val)
			{
				case 0:
					OC1RS = 199;
					break;
				case 1:
					OC1RS = 20;
					break;
				case 2:
					OC1RS = 40;
					break;
				case 3:
					OC1RS = 60;
					break;
				case 4:
					OC1RS = 80;
					break;
				case 5:
					OC1RS = 100;
					break;
				case 6:
					OC1RS = 120;
					break;
				case 7:
					OC1RS = 140;
					break;
				case 8:
					OC1RS = 160;
					break;
				case 9:
					OC1RS = 180;
					break;
			}
		}

		if(rcv2 == 'U' || rcv2 == 'u')
	 	{
			OC1CON = 0x0000;
			OC2CON = 0x000E;
			_LATB15 = 0;
			_LATB6 = 0;
			_LATB7 = 1;
			val = rcv3 - '0';

			switch(val)
			{
				case 0:
					OC2RS = 199;
					break;
				case 1:
					OC2RS = 20;
					break;
				case 2:
					OC2RS = 40;
					break;
				case 3:
					OC2RS = 60;
					break;
				case 4:
					OC2RS = 80;
					break;
				case 5:
					OC2RS = 100;
					break;
				case 6:
					OC2RS = 120;
					break;
				case 7:
					OC2RS = 140;
					break;
				case 8:
					OC2RS = 160;
					break;
				case 9:
					OC2RS = 180;
					break;
			}
		}

	}
else if(rcv1 == 'F' || rcv1 == 'f')
	OC1CON  = OC2CON = 0x0000;
 

//if(rcv3 == '0')
//{
//OC1CON = 0x000E;
//OC1RS = 199;
//OC2CON = 0x0000;
//_LATB15 = 0;
//}
//
//if(rcv3 == '1')
//{
//OC2CON = 0x000E;
//OC2RS = 199;
//OC1CON = 0x0000;
//_LATB9 = 0;
//}

_U1RXIF = 0;
}

void InitRPs()
{
	// Unlock registers
	asm volatile ( 	"MOV #OSCCON,W1 \n"
			"MOV #0x46,W2	\n"
			"MOV #0x57,W3	\n"
			"MOV.b W2,[W1]	\n"
			"MOV.b W3,[W1]	\n"
			"BCLR OSCCON,#6");

	RPINR18bits.U1RXR = 11;		// Assign RP11 to U1RX
	RPOR6bits.RP12R = 3;		// Assign TX to RP12 (0x3)

	RPOR4bits.RP9R = 18; //OC1 sur RP9
	RPOR7bits.RP15R = 19; //OC2 sur RP15
	
	// Lock registers
	asm volatile ( 	"MOV #OSCCON,W1 \n"
			"MOV #0x46,w2	\n"
			"MOV #0x57,w3	\n"
			"MOV.b W2,[W1]	\n"
			"MOV.b W3,[W1]	\n"
			"BSET OSCCON,#6");
}

void InitOC1()
{
OC1CON = 0x0000;// 0x0006;
_LATB9 = 0;
}

void InitOC2()
{
OC2CON = 0x0000; //0x000E;
_LATB15 = 0;
}

void InitT2()
{
T2CON = 0x8010;
PR2 = 199;
TMR2 = 0;
_T2IF = 0;
_T2IE = 0;
_T2IP = 1;
}

void InitT3()
{
T3CON = 0x8010;
PR3 = 199;
TMR3 = 0;
_T3IF = 0;
_T3IE = 0;
_T3IP = 1;
}

void InitUART()
{
U1BRG = 51;
U1MODE = 0x8000;
U1STA = 0x0480;
_U1TXIE = 0;
_U1TXIF = 0;
_U1RXIE = 1;
_U1RXIP = 2;
_U1RXIF = 0;
}

int main()
{
	InitRPs();

	AD1PCFG = 0xFFFF;
	TRISA = 0x0000;
	TRISB = 0x0800;

	InitT2();
	InitT3();
	InitOC1();
	InitOC2();
	InitUART();
	//_LATB7 = 1;

	OC1R = 1;
	OC2R = 1;

	OC1RS = 100;
	OC2RS = 100;
	
	//T3CON = 0x0010;

	while(1)
	{
//		int i,j;
//
//		for(i = 0; i < 1000; i++)
//			for(j = 0; j < 1000; j++);
//		while(U1STAbits.UTXBF);
//		U1TXREG = '0';
	}

	return 0;
}